#!/bin/sh
# $Id: logwatch.SlackBuild,v 1.3 2017/01/20 22:04:44 root Exp root $
# Copyright 2010, 2011, 2017  Eric Hameleers, Eindhoven, NL
# All rights reserved.
#
#   Permission to use, copy, modify, and distribute this software for
#   any purpose with or without fee is hereby granted, provided that
#   the above copyright notice and this permission notice appear in all
#   copies.
#
#   THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
#   WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#   IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# -----------------------------------------------------------------------------
#
# Slackware SlackBuild script 
# ===========================
# By:         Eric Hameleers <alien@slackware.com>
# For:        logwatch
# Descr:      a customizable log analysis system
# URL:        http://sourceforge.net/projects/logwatch/
# Needs:      
# Changelog:  
# 5.2.2-1:   14/feb/2005 by Eric Hameleers
#            * Initial build.
# 5.2.2-2:   23/mar/2006 by Eric Hameleers
#            * Added files for analyzing Cyrus IMAPD logs.
# 7.3.6-1:    25/Nov/2010 by Eric Hameleers <alien@slackware.com>
#             * Update for Slackware 13.1.
# 7.4.0-1:    10/aug/2011 by Eric Hameleers <alien@slackware.com>
#             * Update for Slackware 13.37.
# 7.4.3-1:    20/jan/2017 by Eric Hameleers <alien@slackware.com>
#             * Update for Slackware 14.2.
# 
# Run 'sh logwatch.SlackBuild' to build a Slackware package.
# The package (.tgz) and .txt file as well as build logs are created in /tmp .
# Install it using 'installpkg'. 
#
# -----------------------------------------------------------------------------

# Set initial variables:

PRGNAM=logwatch
VERSION=${VERSION:-7.4.3}
BUILD=${BUILD:-1}
ARCH=noarch
TAG=${TAG:-alien}

DOCS="HOWTO-Customize-LogWatch LICENSE README"

# Where do we look for sources?
SRCDIR=$(cd $(dirname $0); pwd)

# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
TMP=${TMP:-/tmp/build}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}

SOURCE[0]="$SRCDIR/${PRGNAM}-${VERSION}.tar.gz"
SRCURL[0]="http://sourceforge.net/projects/logwatch/files/${PRGNAM}-${VERSION}.tar.gz/download"

SOURCE[1]="$SRCDIR/cyrus.logwatch.tgz"
#SRCURL[1]="http://www.irbs.net/internet/info-cyrus/0401/att-0768/cyrus.logwatch.tgz"
# This one has a slightly newer script:
SRCURL[1]="http://ftp.psu.ac.th/pub/cyrus/cyrus.logwatch.tgz"

##
## --- with a little luck, you won't have to edit below this point --- ##
##

# Exit the script on errors:
set -e
trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
# Catch unitialized variables:
set -u
P1=${1:-1}

# Save old umask and set to 0022:
_UMASK_=$(umask)
umask 0022

# Create working directories:
mkdir -p $OUTPUT          # place for the package to be saved
mkdir -p $TMP/tmp-$PRGNAM # location to build the source
mkdir -p $PKG             # place for the package to be built
rm -rf $PKG/*             # always erase old package's contents
rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
rm -rf $OUTPUT/{configure,make,install,error,makepkg}-$PRGNAM.log
                          # remove old log files

# Source file availability:
for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
  if ! [ -f ${SOURCE[$i]} ]; then
    echo "Source '$(basename ${SOURCE[$i]})' not available yet..."
    # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
    [ -w "$SRCDIR" ] || SOURCE[$i]="$OUTPUT/$(basename ${SOURCE[$i]})"
    if [ -f ${SOURCE[$i]} ]; then echo "Ah, found it!"; continue; fi
    if ! [ "x${SRCURL[$i]}" == "x" ]; then
      echo "Will download file to $(dirname $SOURCE[$i])"
      wget --no-check-certificate -nv -T 20 -O "${SOURCE[$i]}" "${SRCURL[$i]}" || true
      if [ $? -ne 0 -o ! -s "${SOURCE[$i]}" ]; then
        echo "Fail to download '$(basename ${SOURCE[$i]})'. Aborting the build."
        mv -f "${SOURCE[$i]}" "${SOURCE[$i]}".FAIL
        exit 1
      fi
    else
      echo "File '$(basename ${SOURCE[$i]})' not available. Aborting the build."
      exit 1
    fi
  fi
done

if [ "$P1" == "--download" ]; then
  echo "Download complete."
  exit 0
fi

# --- PACKAGE BUILDING ---

echo "++"
echo "|| $PRGNAM-$VERSION"
echo "++"

cd $TMP/tmp-$PRGNAM
echo "Extracting the source archive(s) for $PRGNAM..."
for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
  tar -xvf ${SOURCE[$i]}
done
chown -R root:root *
chmod -R u+w,go+r-w,a+X-s *
cd ${PRGNAM}-${VERSION}

# Add support for .xz compressed archives:
cat $SRCDIR/patches/logwatch.xz-support.patch |patch -p0 --verbose \
  2>&1 | tee $OUTPUT/patch-${PRGNAM}.log

echo Building ...

# Install the scripts, configuration files to their proper locations:
install -m 0755 -d $PKG/var/cache/logwatch
install -m 0755 -d $PKG/etc/logwatch/scripts
install -m 0755 -d $PKG/etc/logwatch/scripts/services
install -m 0755 -d $PKG/etc/logwatch/conf
install -m 0755 -d $PKG/etc/logwatch/conf/logfiles
install -m 0755 -d $PKG/etc/logwatch/conf/services
install -m 0755 -d $PKG/usr/share/logwatch/default.conf/logfiles
install -m 0755 -d $PKG/usr/share/logwatch/default.conf/services
install -m 0755 -d $PKG/usr/share/logwatch/default.conf/html
install -m 0755 -d $PKG/usr/share/logwatch/dist.conf/logfiles
install -m 0755 -d $PKG/usr/share/logwatch/dist.conf/services
install -m 0755 -d $PKG/usr/share/logwatch/scripts/services
install -m 0755 -d $PKG/usr/share/logwatch/scripts/shared
install -m 0755 -d $PKG/usr/share/logwatch/lib

install -m 0755 scripts/logwatch.pl $PKG/usr/share/logwatch/scripts/logwatch.pl

for i in scripts/logfiles/* ; do
   if [ $(ls $i | wc -l) -ne 0 ] ; then
      install -m 0755 -d $PKG/usr/share/logwatch/$i
      install -m 0755 $i/* $PKG/usr/share/logwatch/$i
   fi
done
install -m 0755 scripts/services/* $PKG/usr/share/logwatch/scripts/services
install -m 0755 scripts/shared/* $PKG/usr/share/logwatch/scripts/shared
install -m 0755 lib/* $PKG/usr/share/logwatch/lib

install -m 0644 conf/*.conf $PKG/usr/share/logwatch/default.conf
install -m 0644 conf/logfiles/* $PKG/usr/share/logwatch/default.conf/logfiles
install -m 0644 conf/services/* $PKG/usr/share/logwatch/default.conf/services
install -m 0644 conf/html/* $PKG/usr/share/logwatch/default.conf/html

install -m 0755 -d $PKG/usr/man/man8
install -m 0644 logwatch.8 $PKG/usr/man/man8
install -m 0755 -d $PKG/usr/man/man5
install -m 0644 ignore.conf.5 $PKG/usr/man/man5
install -m 0644 logwatch.conf.5 $PKG/usr/man/man5
install -m 0644 override.conf.5 $PKG/usr/man/man5
install -m 0755 -d $PKG/usr/man/man1
install -m 0644 amavis-logwatch.1 $PKG/usr/man/man1
install -m 0644 postfix-logwatch.1 $PKG/usr/man/man1

rm -f $PKG/etc/cron.daily/logwatch $PKG/usr/sbin/logwatch

install -m 0755 -d $PKG/etc/cron.daily
ln -s /usr/share/logwatch/scripts/logwatch.pl $PKG/etc/cron.daily/0logwatch
install -m 0755 -d $PKG/usr/sbin
ln -s /usr/share/logwatch/scripts/logwatch.pl $PKG/usr/sbin/logwatch

echo "###### REGULAR EXPRESSIONS IN THIS FILE WILL BE TRIMMED FROM REPORT OUTPUT #####" > $PKG/etc/logwatch/conf/ignore.conf
echo "# Local configuration options go here (defaults are in /usr/share/logwatch/default.conf/logwatch.conf)" > $PKG/etc/logwatch/conf/logwatch.conf
echo "# Configuration overrides for specific logfiles/services may be placed here." > $PKG/etc/logwatch/conf/override.conf

# Install the cyrus-imapd add-on:
install -m 0644 ../etc/log.d/conf/logfiles/imapd.conf \
  $PKG/usr/share/logwatch/default.conf/logfiles
install -m 0644 ../etc/log.d/conf/services/cyrus.conf \
  $PKG/usr/share/logwatch/default.conf/services
install -m 0755 ../etc/log.d/scripts/services/cyrus \
  $PKG/usr/share/logwatch/scripts/services
# Only use relevant bits of the maillog:
cat <<EOT >> $PKG/usr/share/logwatch/default.conf/services/cyrus.conf
# Only give lines pertaining to cyrus...
# I'm not sure if this is complete
*OnlyService = (imap|imaps|master|ctl_cyrusdb|tls_prune)

EOT

# Add documentation:
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
find $PKG/usr/doc -type f -exec chmod 644 {} \;

# Compress the man page(s):
if [ -d $PKG/usr/man ]; then
  find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
  for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
fi

# Add a package description:
mkdir -p $PKG/install
cat $SRCDIR/slack-desc > $PKG/install/slack-desc

# Build the package:
cd $PKG
makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
cd $OUTPUT
md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz}.md5
cd -
cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt

# Restore the original umask:
umask ${_UMASK_}

